//
// This file is part of LiRE, a free, experimental library for
// efficient testing of determinism and membership for regular
// expressions.
//
// LiRE is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, version 3 of the License, or any
// later version.
//
// LiRE is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
// License for more details.
//
// You should have received a copy of the GNU General Public License
// along with LiRE. If not, see <http://www.gnu.org/licenses/>.
//
// Authors: Sławek Staworko <staworko@gmail.com>
//          Benoît Groz <benoit.groz@yahoo.fr>
//          Sebastian Maneth <sebastian.maneth@gmail.com>
// Date: 20 June 2011.
//

#include <stdlib.h>

#include "logger.h"

void _LiRE_handle_error(const char* file_name, 
                        const int line_no, 
                        const char* format,...)
{
   va_list ap;
   va_start(ap,format);
   Logger::getLogger()->msg(Logger::ERROR_LEVEL,file_name,line_no,format,ap);
   va_end(ap);
   exit(1);
}

void _LiRE_handle_assertion_failure(const char* file_name, 
                                    const int line_no, 
                                    const char* format,
                                    ...)
{
   va_list ap;
   va_start(ap,format);
   Logger::getLogger()->msg(Logger::ERROR_LEVEL,file_name,line_no,format,ap);
   va_end(ap);
   exit(1);
}

