%{
//
// This file is part of LiRE, a free, experimental library for
// efficient testing of determinism and membership for regular
// expressions.
//
// LiRE is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, version 3 of the License, or any
// later version.
//
// LiRE is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
// License for more details.
//
// You should have received a copy of the GNU General Public License
// along with LiRE. If not, see <http://www.gnu.org/licenses/>.
//
// Authors: Sławek Staworko <staworko@gmail.com>
//          Benoît Groz <benoit.groz@yahoo.fr>
//          Sebastian Maneth <sebastian.maneth@gmail.com>
// Date: 20 June 2011.
//

#include <stdio.h>
#include "alphabet.h"
#include "regexpr.h"
#include "regexpr_parser.h"   

extern YYSTYPE lire_regexpr_yylval;

%}

%option noyywrap

%%
\( return OP;
\) return CP;
\| return BAR_T;
\, return COMMA_T;
"EMPTY" return EMPTY_T;
[a-zA-Z0-9.-]* {lire_regexpr_yylval.name=yytext; return NAME_T;}
\* return AST_T;
\? return OPT_T;
\+ return PLUS_T;
[ \t\n]+ /* ignore whitespace */;
%%
