#include "timer.h"

Timer* Timer::global = new Timer();

void Timer::Start()
{
   Timer::global->start();
}

void Timer::Stop()
{
   Timer::global->stop();
}

void Timer::Reset()
{
   Timer::global->reset();
}

int Timer::Elapsed()
{
   return Timer::global->elapsed;
}

Timer::Timer()
{
   this->pause_level = 1;
   this->elapsed = 0;
   this->started_at = 0;
}

Timer::~Timer()
{
}

void Timer::start()
{
   ASSERT(this->pause_level > 0);

   this->pause_level--;

   if (this->pause_level == 0) {
      this->started_at = clock() / (CLOCKS_PER_SEC / 1000);
   }
}


void Timer::stop()
{
   ASSERT(this->pause_level >= 0);

   if (this->pause_level == 0) { 
      long t = clock() / (CLOCKS_PER_SEC / 1000);
      
      this->elapsed += t - this->started_at;
      this->started_at = 0;
   }
   this->pause_level++;
}

void Timer::reset()
{
   this->pause_level = 1;
   this->started_at = 0;
   this->elapsed = 0;
}
