//
// This file is part of LiRE, a free, experimental library for
// efficient testing of determinism and membership for regular
// expressions.
//
// LiRE is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, version 3 of the License, or any
// later version.
//
// LiRE is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public
// License for more details.
//
// You should have received a copy of the GNU General Public License
// along with LiRE. If not, see <http://www.gnu.org/licenses/>.
//
// Authors: Sławek Staworko <staworko@gmail.com>
//          Benoît Groz <benoit.groz@yahoo.fr>
//          Sebastian Maneth <sebastian.maneth@gmail.com>
// Date: 20 June 2011.
//
#ifndef LiRE_TIMER_H_
#define LiRE_TIMER_H_

#include <time.h>
#include "error.h"

struct Timer
{
   static Timer* global;
   static void Start();
   static void Stop();
   static void Reset();
   static int  Elapsed();

   int pause_level;
   
   long elapsed;
   long started_at;
   
   Timer();
   ~Timer();

   void start();
   void stop();
   void reset();
};


#endif //LiRE_TIMING_H_
