#include "utils.h"
#include "glushkov.h"
#include "tree.h"
#include "gtest/gtest.h"
#include "regexpr.h"

TEST(DeterminismT,FixedInstance)
{
   RegExpr* e = RegExpr::parse_str("a,b");
   
   Glushkov* g = new Glushkov(e);
   Tree* t = new Tree(e);
   
   EXPECT_EQ(g->is_deterministic(),t->is_deterministic());
   
   delete e;
   delete g;
   delete t;
}

TEST(DeterminismT,RandomRegExpr) {
   for (int i = 0; i < 10; i++) {
      RegExpr* e = RegExpr::random_re(120,750);

      Glushkov* g = new Glushkov(e);
      Tree* t = new Tree(e);

      EXPECT_EQ(g->is_deterministic(),t->is_deterministic());
   
      delete e;
      delete g;
      delete t;
   }
}

